﻿/*******************************************************************************
File        : Program.cs
Description : 
--------------------------------------------------------------------------------
Functions:
--------------------------------------------------------------------------------
History:
2011/05/13 TPR Created
*******************************************************************************/
using System;
using Wiker.WIDatabase;
using System.Text;

namespace Count
{
   /*******************************************************************************
   Class        : Program
   Description  : 
   --------------------------------------------------------------------------------
   History:
   2011/05/13 TPR Created
   *******************************************************************************/
   class Program
   {      
      /*******************************************************************************
      Function    : Main()
      Description : 
      Parameters  : string[] args - 
      Returns     : void
      --------------------------------------------------------------------------------
      History:
      2011/05/13 TPR Created
      *******************************************************************************/
      static void Main(string[] args)
      {         
         WIDatabase WIDB;
         int Total, PersonTotal;
         CDatabaseInfo DBInfo;

         /* Create DatabaseInfo object with login info  */
         DBInfo = new CDatabaseInfo();
         DBInfo.DatabaseType = eDatabaseType.SQLite;
         DBInfo.Location =  "\\WIDatabase\\Samples";
         DBInfo.DBName = "SQLite.db3";         
         DBInfo.Password = "";
         DBInfo.Port = 0;
         DBInfo.Username = "";

         Total = 0;
         PersonTotal = 0;
         /* Create WIDatabase object */         
         WIDB = new WIDatabase(DBInfo);

         /* Calling Select.Clear() ensures we starting with a new select statement. */
         WIDB.Search.Clear();

         /* Select.Table: The 'Main' table from which the data will originate */
         WIDB.Search.Table("tblPhone");

         /* Return number of records in table using alias 'Count' */
         WIDB.Search.Count("Count");

         /* Return number of records where column 'PersonID' is not null */
         WIDB.Search.Count("PersonCount", "PersonID");
         
         /* Select.Execute() prepares the statement to be sent to the Database */         
         if (!WIDB.Search.Execute())
            {
            Console.WriteLine(string.Format("Failed To Search Table\n{0} - {1}", WIDB.LastError.ToString(), WIDB.LastErrorMessage));
            return;
            }

         while (WIDB.Search.Read())
            {
            WIDB.Search.Get("Count", out Total);
            WIDB.Search.Get("PersonCount", out PersonTotal);
            }

         Console.WriteLine(string.Format("Count:  {0}  | PersonCount:  {1}",Total,PersonTotal));

         /* Good practice is to close the DB when finished */
         WIDB.Close();
      }
   }/* End Class */
}/* End NameSpace */
