﻿Imports Wiker.WIDatabase
Module Module1

    Sub Main()
    Dim WIDB As WIDatabase
        Dim Str As String
        Dim DBInfo As CDatabaseInfo

        ' Create DatabaseInfo object with login info  

        DBInfo = New CDatabaseInfo()
        DBInfo.DatabaseType = eDatabaseType.SQLite
        DBInfo.Location = "\WIDatabase\Samples"
        DBInfo.DBName = "SQLite.db3"
        DBInfo.Password = ""
        DBInfo.Port = 0
        DBInfo.Username = ""

        ' Create WIDatabase object 

        WIDB = New WIDatabase(DBInfo)

        ' Table.Clear() ensures we are not creating extraneous tables 

        WIDB.Table.Clear()

        ' Each call to Table.Column adds a column to the table. 

        ' has an index of 0
        WIDB.Table.Column("AddressID", eDataType.Int32)

        ' has an index of 1
        WIDB.Table.Column("Address1", eDataType.Text, 255)

        ' has an index of 2 
        WIDB.Table.Column("Address2", eDataType.Text, 255)

        ' has an index of 3
        WIDB.Table.Column("City", eDataType.Text, 255)

        ' has an index of 4
        WIDB.Table.Column("State", eDataType.Text, 255)

        ' has an index of 5
        WIDB.Table.Column("ZipCode", eDataType.Text, 12)


        ' PrimaryColumn: list of columns, when used together make, that make the row unique. 

        WIDB.Table.PrimaryColumn("AddressID")

        ' AutoIncrementColumn: sets the column to increment its value automatically 

        WIDB.Table.AutoIncrementColumn("AddressID")

        ' Table.Execute([tableName]) creates the table as defined by the previous calls 

        If Not WIDB.Table.Create("tblAddress") Then
            Str = String.Format("Failed to create table tblAddress" & vbLf & "LastError = {0}" & vbLf & "{1}", WIDB.LastError.ToString(), WIDB.LastErrorMessage)
        Else
            Str = "Table tblAddress Created"
        End If

        Console.WriteLine(Str)

        ' Good practice to close the DB when finished 

        WIDB.Close()

    End Sub

End Module
