﻿/*******************************************************************************
File        : DropSELECT.cs
Description : 
--------------------------------------------------------------------------------
Functions:
--------------------------------------------------------------------------------
History:
2011/04/27 WLM Created
*******************************************************************************/
using System;
using System.Windows.Forms;
using System.Drawing;
using Wiker.WIDatabase;
using System.Text;
using System.Collections.ObjectModel;

namespace WIDatabaseSample
{
/*******************************************************************************
Class        : MainForm
Description  : 
--------------------------------------------------------------------------------
History:
2011/04/12 WLM Created
*******************************************************************************/
public partial class MainForm
{
/*******************************************************************************
Function    : DropSQLiteSELECT()
Description : 
Parameters  : CDatabaseInfo databaseInfo - 
Returns     : bool
--------------------------------------------------------------------------------
History:
2011/05/04 WLM Created
*******************************************************************************/
public bool DropSQLiteSELECT(CDatabaseInfo databaseInfo)
{
WIDBUtil dbUtil;
StringBuilder StrB;
string Str;

/* Create Connection To Database */
dbUtil = new WIDBUtil(databaseInfo);

if (dbUtil.LastError != eDBErrorCodes.None)
   return(false);

/*----------------------------------------------------------------------------*/

try
{
StrB = new StringBuilder();

StrB.Append("DROP TABLE IF EXISTS tblAddress;");
StrB.Append("DROP TABLE IF EXISTS tblCompany;");
StrB.Append("DROP TABLE IF EXISTS tblImage;");
StrB.Append("DROP TABLE IF EXISTS tblPerson;");
StrB.Append("DROP TABLE IF EXISTS tblPhone;");
StrB.AppendFormat("DROP DATABASE IF EXISTS {0};", WIDBUtil.BracketName(databaseInfo.DBName, eDatabaseType.SQLite));

dbUtil.Open();

if (!dbUtil.ExecuteTransaction(StrB.ToString()))
   {
   dbUtil.Close();
   return(false);
   }

dbUtil.Close();

return(true);
}

catch (Exception ex)
   {
   dbUtil.Close();
   Str = string.Format("Failed to DROP Tables\n{0}", ex.Message);
   MessageBox.Show(Str);
   return(false);
   }
}
/*******************************************************************************
Function    : DropSQLSELECT()
Description : 
Parameters  : CDatabaseInfo databaseInfo - 
Returns     : bool
--------------------------------------------------------------------------------
History:
2011/05/04 WLM Created
*******************************************************************************/
public bool DropSQLSELECT(CDatabaseInfo databaseInfo)
{
WIDBUtil dbUtil;
StringBuilder StrB;
Collection<string> QueryList;
string Str, DBName;

/* Create Connection To Database */
dbUtil = new WIDBUtil(databaseInfo);

if (dbUtil.LastError != eDBErrorCodes.None)
   return(false);

QueryList = new Collection<string>();

/*----------------------------------------------------------------------------*/

/* DROP TABLE tblAddress */
StrB = new StringBuilder();
StrB.Append("IF EXISTS");
StrB.Append("   (");
StrB.Append("   SELECT *");
StrB.Append("   FROM sys.objects");
StrB.Append("   WHERE object_id = OBJECT_ID(N'tblAddress') AND");
StrB.Append("   type in (N'U')");
StrB.Append("   )");
StrB.Append("DROP TABLE tblAddress");
QueryList.Add(StrB.ToString());

/* DROP TABLE tblCompany */
StrB = new StringBuilder();
StrB.Append("IF EXISTS");
StrB.Append("   (");
StrB.Append("   SELECT *");
StrB.Append("   FROM sys.objects");
StrB.Append("   WHERE object_id = OBJECT_ID(N'tblCompany') AND");
StrB.Append("   type in (N'U')");
StrB.Append("   )");
StrB.Append("DROP TABLE tblCompany");
QueryList.Add(StrB.ToString());

/* DROP TABLE tblImage */
StrB = new StringBuilder();
StrB.Append("IF EXISTS");
StrB.Append("   (");
StrB.Append("   SELECT *");
StrB.Append("   FROM sys.objects");
StrB.Append("   WHERE object_id = OBJECT_ID(N'tblImage') AND");
StrB.Append("   type in (N'U')");
StrB.Append("   )");
StrB.Append("DROP TABLE tblImage");
QueryList.Add(StrB.ToString());

/* DROP TABLE tblPerson */
StrB = new StringBuilder();
StrB.Append("IF EXISTS");
StrB.Append("   (");
StrB.Append("   SELECT *");
StrB.Append("   FROM sys.objects");
StrB.Append("   WHERE object_id = OBJECT_ID(N'tblPerson') AND");
StrB.Append("   type in (N'U')");
StrB.Append("   )");
StrB.Append("DROP TABLE tblPerson");
QueryList.Add(StrB.ToString());

/* DROP TABLE tblPhone */
StrB = new StringBuilder();
StrB.Append("IF EXISTS");
StrB.Append("   (");
StrB.Append("   SELECT *");
StrB.Append("   FROM sys.objects");
StrB.Append("   WHERE object_id = OBJECT_ID(N'tblPhone') AND");
StrB.Append("   type in (N'U')");
StrB.Append("   )");
StrB.Append("DROP TABLE tblPhone");
QueryList.Add(StrB.ToString());

/* DROP Database */
DBName = WIDBUtil.BracketName(databaseInfo.DBName, eDatabaseType.SQL);

StrB = new StringBuilder();
StrB.Append("IF  EXISTS ");
StrB.Append("   (");
StrB.AppendFormat("   SELECT {0} ", DBName);
StrB.Append("   FROM sys.databases ");
StrB.AppendFormat("   WHERE name = N'{0}'", DBName);
StrB.Append("   )");
StrB.AppendFormat("DROP DATABASE [{0}]", DBName);
QueryList.Add(StrB.ToString());

/*----------------------------------------------------------------------------*/

try
{
dbUtil.Open();

if (!dbUtil.ExecuteTransaction(QueryList))
   {
   dbUtil.Close();
   return(false);
   }

dbUtil.Close();

return(true);
}

catch (Exception ex)
   {
   dbUtil.Close();
   Str = string.Format("Failed to DROP Tables\n{0}", ex.Message);
   MessageBox.Show(Str);
   return(false);
   }
}
/*******************************************************************************
Function    : DropMySqlSELECT()
Description : 
Parameters  : CDatabaseInfo databaseInfo - 
Returns     : bool
--------------------------------------------------------------------------------
History:
2011/05/04 WLM Created
*******************************************************************************/
public bool DropMySqlSELECT(CDatabaseInfo databaseInfo)
{
WIDBUtil dbUtil;
StringBuilder StrB;
string Str;

/* Create Connection To Database */
dbUtil = new WIDBUtil(databaseInfo);

if (dbUtil.LastError != eDBErrorCodes.None)
   return(false);

/*----------------------------------------------------------------------------*/

try
{
StrB = new StringBuilder();

StrB.Append("DROP TABLE IF EXISTS tblAddress;");
StrB.Append("DROP TABLE IF EXISTS tblCompany;");
StrB.Append("DROP TABLE IF EXISTS tblImage;");
StrB.Append("DROP TABLE IF EXISTS tblPerson;");
StrB.Append("DROP TABLE IF EXISTS tblPhone;");
StrB.AppendFormat("DROP DATABASE IF EXISTS {0};", WIDBUtil.BracketName(databaseInfo.DBName, eDatabaseType.MySql));

dbUtil.Open();

if (!dbUtil.ExecuteTransaction(StrB.ToString()))
   {
   dbUtil.Close();
   return(false);
   }

dbUtil.Close();

return(true);
}

catch (Exception ex)
   {
   dbUtil.Close();
   Str = string.Format("Failed to DROP Tables\n{0}", ex.Message);
   MessageBox.Show(Str);
   return(false);
   }
}
} /* End Of Class MainForm */
} /* End Of NameSpace WIDatabaseSample */